require 'sketchup.rb'

=begin

10-05-2012
bruteforce_nested.rb
By Liquid

Get Real world coordinates out of nested sets of groups/componentinstances.
The brute force way.

Concept taken from:
-------------------
'SketchUp to DXF STL Converter'

Credit goes to:
Nathan Bromham
Konrad Shroeder

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

=end 


module Liquid
	module Real_World_Coordinates
	 
	  unless file_loaded?(File.basename(__FILE__))
		 menu = UI.menu( 'Plugins' )
		 menu.add_item( 'Find real world coordinates  la Brute Force ' ) { self::Brute.new()}
	  end

	class Brute
		def initialize
			@model = Sketchup.active_model
			@entities = @model.active_entities
			@sel = @model.selection
			tr = Geom::Transformation.new
			find(@sel, tr)
		end
	
		def find(entities,tr)
			entities.each { |ent|
				quant_edge(ent.edges,tr) if ent.is_a? Sketchup::Face
				quant_edge([ent],tr) if ent.is_a? Sketchup::Edge
				find(ent.entities, tr * ent.transformation) if ent.is_a? Sketchup::Group
				find(ent.definition.entities, tr * ent.transformation) if ent.is_a? Sketchup::ComponentInstance
			}
		end	
		
		def quant_edge(edges,tr)
			vtx = []
			edges.each { |edge| vtx.push(edge.vertices) }
			# Go from vertex to (transformed) coordinate.
			vtx.flatten!.map! { |vt| 
				vt = vt.position
				vt.transform(tr) 
			}
			# Draw points:
			vtx.each { |pt| @entities.add_cpoint (pt) }
		end	
		
	end#class	
	 
	  file_loaded(File.basename(__FILE__))
	 
	end # module
end # module